unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { private declarations }
  public
    function crash(n:integer):real;
    function dontcrash(n:integer):real;
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

function TForm1.crash(n:integer):real;
begin
  case n of
  0:    Result:=0;
  1..100: Result:=crash(n-1)+crash(n-1);
  end;
end;

function TForm1.dontcrash(n:integer):real;
var mem1, mem2:real;
begin
  case n of
  0:    Result:=0;
  1..100: begin
            mem1:=dontcrash(n-1);
            mem2:=dontcrash(n-1);
            Result:=mem1+mem2;
          end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Form1.Caption:=FloatToStr(crash(StrToInt(Edit1.Text)));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Form1.Caption:=FloatToStr(dontcrash(StrToInt(Edit1.Text)));
end;

initialization
  {$I unit1.lrs}

end.

